## cppad 2014.00.00.3

=== CMakeLists.txt ===
# $Id: CMakeLists.txt 3099 2014-02-18 03:29:44Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-14 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
# Set the minimum required version of cmake for this project.
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# cppad_version is used by set_version.sh to get the version number.
SET(cppad_version      "20140000.3" )
SET(cppad_url          "http://www.coin-or.org/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )


# Set name of this project and create the variables 
# cppad_BINARY_DIR and cppad_SOURCE_DIR. 
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)

# Add this directory to the list of C++ preprocessor include directories
# for the entire project.
# include_directories([AFTER|BEFORE] [SYSTEM] dir1 dir2 ...)
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR} )



# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set 
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES 
# accordingly if additional libraries or compiler flags are required. 
INCLUDE(CheckCXXSourceRuns)

# ============================================================================
# Some local cmake language
# ============================================================================
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
# 
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# optional_package(prefix_variable description)
INCLUDE(cmake/optional_package.cmake)
#
# add_cppad_cxx_flags(target_name)
INCLUDE(cmake/add_cppad_cxx_flags.cmake)
# =============================================================================
# command line arguments
# =============================================================================
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING 
	"directory, below prefix, where cmake installs cppad data files"
)
# -----------------------------------------------------------------------------
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING 
	"directories, below prefix, where cmake installs include files"
)
# -----------------------------------------------------------------------------
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING 
	"directories, below prefix, where cmake installs library files"
)
# -----------------------------------------------------------------------------
# cmake_install_prefix
command_line_arg(cmake_install_prefix /usr PATH 
	"cppad install prefix"
)
SET(CMAKE_INSTALL_PREFIX "${cmake_install_prefix}" 
	CACHE PATH "value copied from cmake_install_prefix" FORCE
)
# -----------------------------------------------------------------------------
# cmake_install_postfix
command_line_arg(cmake_install_postfix NOTFOUND STRING 
	"cppad install postfix"
)
# -----------------------------------------------------------------------------
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags NOTFOUND STRING 
	"extra flags used with cppad source (besides debug and release flags)"
)
# -----------------------------------------------------------------------------
# cppad_documentation
command_line_arg(cppad_documentation NO BOOL 
	"install cppad documentation"
)
# -----------------------------------------------------------------------------
# External package prefixes
#
# adolc_prefix
optional_package(adolc_prefix "adolc install prefix")
#
# eigen_prefix
optional_package(eigen_prefix "eigen install prefix")
#
# fadbad_prefix
optional_package(fadbad_prefix "fadbad install prefix")
#
# ipopt_prefix
optional_package(ipopt_prefix "ipopt install prefix")
#
# sacado_prefix
optional_package(sacado_prefix "sacado install prefix")
# =============================================================================
# automated system configuration
# =============================================================================
# cppad_install_includedir
SET(cppad_install_includedir NOTFOUND)
FOREACH(dir ${cmake_install_includedirs})
	IF( NOT cppad_install_includedir )
		SET(cppad_install_includedir ${dir})
	ENDIF( NOT cppad_install_includedir )
ENDFOREACH(dir ${cmake_install_includedirs})
# -----------------------------------------------------------------------------
# cppad_install_libdir
SET(cppad_install_libdir NOTFOUND)
FOREACH(dir ${cmake_install_libdirs})
	IF( NOT cppad_install_libdir )
		SET(cppad_install_libdir ${dir})
	ENDIF( NOT cppad_install_libdir )
ENDFOREACH(dir ${cmake_install_libdirs})
# -----------------------------------------------------------------------------
# cppad_cxx_flags_sacado
IF( ${cppad_cxx_flags} MATCHES ".*-std=c[+][+]11.*" )
	SET(cppad_cxx_flags_sacado "${cppad_cxx_flags} -D HAS_C99_TR1_CMATH" )
ELSE( ${cppad_cxx_flags} MATCHES ".*-std=c[+][+]11.*" )
	SET(cppad_cxx_flags_sacado ${cppad_cxx_flags} )
ENDIF( ${cppad_cxx_flags} MATCHES ".*-std=c[+][+]11.*" )
MESSAGE(STATUS "cppad_cxx_flags_sacado = ${cppad_cxx_flags_sacado}")
# -----------------------------------------------------------------------------
# cppad_cxx_flags_skip_eigen
STRING(REGEX REPLACE 
	"(.*)-Wshadow(.*)"         "\\1 \\2" 
	cppad_cxx_flags_eigen "${cppad_cxx_flags}"
)
MESSAGE(STATUS "cppad_cxx_flags_eigen = ${cppad_cxx_flags_eigen}")
# -----------------------------------------------------------------------------
# cppad_cxx_flags_skip_fadbad
STRING(REGEX REPLACE 
	"(.*)-Wshadow(.*)"         "\\1 \\2" 
	cppad_cxx_flags_fadbad "${cppad_cxx_flags}"
)
MESSAGE(STATUS "cppad_cxx_flags_fadbad = ${cppad_cxx_flags_fadbad}")
# -----------------------------------------------------------------------------
# cppad_abs_includedir, cppad_abs_libdir, cppad_abs_datadir, cppad_abs_docdir
IF ( cmake_install_postfix )
	SET(cppad_abs_includedir 
"${cmake_install_prefix}/${cppad_install_includedir}/${cmake_install_postfix}" 
		CACHE INTERNAL "cppad install include file directory" FORCE
	)
	SET(cppad_abs_libdir 
"${cmake_install_prefix}/${cppad_install_libdir}/${cmake_install_postfix}" 
		CACHE INTERNAL "cppad install library file directory" FORCE
	)
	SET(cppad_abs_datadir 
"${cmake_install_prefix}/${cmake_install_datadir}/${cmake_install_postfix}" 
		CACHE INTERNAL "cppad install data file directory" FORCE
	)
	SET(cppad_abs_docdir 
"${cmake_install_prefix}/${cmake_install_datadir}/doc/${cmake_install_postfix}" 
		CACHE INTERNAL "cppad install data file directory" FORCE
	)
ELSE ( cmake_install_postfix )
	SET(cppad_abs_includedir 
		"${cmake_install_prefix}/${cppad_install_includedir}" 
		CACHE INTERNAL "cppad install include file directory" FORCE
	)
	SET(cppad_abs_libdir 
		"${cmake_install_prefix}/${cppad_install_libdir}" 
		CACHE INTERNAL "cppad install library file directory" FORCE
	)
	SET(cppad_abs_datadir 
		"${cmake_install_prefix}/${cmake_install_datadir}" 
		CACHE INTERNAL "cppad install data file directory" FORCE
	)
	SET(cppad_abs_docdir 
		"${cmake_install_prefix}/${cmake_install_datadir}/doc" 
		CACHE INTERNAL "cppad install data file directory" FORCE
	)
ENDIF ( cmake_install_postfix )
# -----------------------------------------------------------------------------
# boost_prefix
FIND_PACKAGE(Boost)
IF ( Boost_FOUND )
	# Extract the Boost prefix from Boost_INCLUDE_DIRS
	#
	# convert to using unix directory separator
	dos_path_to_unix("${Boost_INCLUDE_DIRS}" boost_include_dirs)
	#
	# convert to just one directory
	STRING(REGEX REPLACE
		"([^ ]+).*" "\\1"
		boost_include_dir "${boost_include_dirs}"
	)
	#
	# extract part before last backslash
	STRING(REGEX REPLACE 
		"([^ ]*)/[^/ ]*" "\\1" 
		boost_prefix "${boost_include_dir}" 
	) 
	MESSAGE(STATUS "boost_prefix = ${boost_prefix}")
	#
	# add boost include directories
	FOREACH(dir ${cmake_install_includedirs})
		IF( IS_DIRECTORY ${boost_prefix}/${dir} )
			INCLUDE_DIRECTORIES( ${boost_prefix}/${dir} )
			MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
		ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
	ENDFOREACH( dir )
	#
	# add boost link directories
	FOREACH(dir ${cmake_install_libdirs})
		IF( IS_DIRECTORY ${boost_prefix}/${dir} )
			LINK_DIRECTORIES( ${boost_prefix}/${dir} )
			MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
		ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
	ENDFOREACH( dir )
ENDIF ( Boost_FOUND )
# -----------------------------------------------------------------------------
# ipopt_LIBRARIES and ipopt_LIBRARY_DIRS
IF( ipopt_prefix )
	FIND_PACKAGE(PkgConfig)
	IF( NOT PKG_CONFIG_FOUND )
		MESSAGE(FATAL_ERROR "Using ipopt_prefix but cannot find pkg-config")
	ENDIF( NOT PKG_CONFIG_FOUND )
	#
	# Set the system environment variable PKG_CONFIG_PATH
	FOREACH(dir ${cmake_install_libdirs})
		IF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
			SET( ENV{PKG_CONFIG_PATH} ${ipopt_prefix}/${dir}/pkgconfig )
		ENDIF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
	ENDFOREACH(dir)
	#
	# pkg_check_modules(<PREFIX> [REQUIRED] <MODULE> [<MODULE>]*)
	# ipopt_LIBRARIES      ... only the libraries (w/o the '-l')
	# ipopt_LIBRARY_DIRS   ... the paths of the libraries (w/o the '-L')
	pkg_check_modules(ipopt ipopt)
	IF( NOT ipopt_FOUND )
		MESSAGE(FATAL_ERROR 
"For all directories dir in cmake_install_libdirs, cannot find the file
	ipopt_prefix/dir/pkgconfig/ipopt.pc 
where
	ipopt_prefix = ${ipopt_prefix}
	cmake_install_libdirs = ${cmake_install_libdirs}
"
		)
	ENDIF( NOT ipopt_FOUND )
ENDIF( ipopt_prefix )
# =============================================================================
# Currently building tests as normal executables
# =============================================================================
# The CMakeLists.txt file in the specified source directory is processed 
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
#
# Initialize list of tests as empty
SET(list_check "")
#
ADD_SUBDIRECTORY(cppad)
ADD_SUBDIRECTORY(pkgconfig)
#
ADD_SUBDIRECTORY(compare_c)
add_to_list(list_check check_compare_c)
#
ADD_SUBDIRECTORY(example)
add_to_list(list_check check_example)
#
ADD_SUBDIRECTORY(introduction)
add_to_list(list_check check_introduction)
#
ADD_SUBDIRECTORY(print_for)
add_to_list(list_check check_print_for)
#
ADD_SUBDIRECTORY(test_more)
add_to_list(list_check check_test_more)
#
ADD_SUBDIRECTORY(multi_thread)
add_to_list(list_check check_multi_thread)
#
ADD_SUBDIRECTORY(speed)
add_to_list(list_check check_speed)
#
IF ( ipopt_prefix )
	ADD_SUBDIRECTORY(cppad_ipopt)
	add_to_list(list_check check_ipopt_nlp)
ENDIF( ipopt_prefix )
#
ADD_CUSTOM_TARGET(check DEPENDS ${list_check})
#
# =============================================================================
# install procedure
# =============================================================================
# install(DIRECTORY dirs... DESTINATION <dir>
#	[FILE_PERMISSIONS permissions...]
#	[DIRECTORY_PERMISSIONS permissions...]
#	[USE_SOURCE_PERMISSIONS] [OPTIONAL]
#	[CONFIGURATIONS [Debug|Release|...]]
#	[COMPONENT <component>] [FILES_MATCHING]
#	[[PATTERN <pattern> | REGEX <regex>]

=== cppad/CMakeLists.txt ===
#CppAD $Id: CMakeLists.txt 3064 2013-12-28 18:01:30Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-13 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad/configure.hpp file.
# Inherit environment from ../CMakeLists.txt
# -----------------------------------------------------------------------------
MACRO(check_match match_variable match_constant output_variable) 
	STRING(COMPARE EQUAL ${${match_variable}} ${match_constant} match_flag )
	IF( match_flag )
		SET(${output_variable} 1)
	ELSE( match_flag )
		SET(${output_variable} 0)
	ENDIF( match_flag )
	MESSAGE(STATUS "${output_variable} = ${${output_variable}}" )
ENDMACRO(check_match)
# -----------------------------------------------------------------------------
# command line arguments
#
# cppad_testvector 
command_line_arg(cppad_testvector cppad STRING
"Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
	"maximum number of threads that CppAD can use use"
)
# cppad_sparse_list
command_line_arg(cppad_sparse_list YES BOOL 
	"use sparse list for internal sparse set representation"
)
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
	"type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
#
# cppad_implicit_ctor_from_any_type_from_any_type
command_line_arg(cppad_implicit_ctor_from_any_type_from_any_type NO BOOL 
	"implicit (instead of explicit) conversion from any type to AD<Base>"
)
# -----------------------------------------------------------------------------
# cppad_explicit_ctor
IF( cppad_implicit_ctor_from_any_type_from_any_type )
	SET(cppad_implicit_ctor_from_any_type 1)
ELSE( cppad_implicit_ctor_from_any_type_from_any_type )
	SET(cppad_implicit_ctor_from_any_type 0)
ENDIF( cppad_implicit_ctor_from_any_type_from_any_type )
# -----------------------------------------------------------------------------
# cppad_internal_sparse_set
#
IF( cppad_sparse_list )
	SET(cppad_internal_sparse_set  sparse_list )
ELSE( cppad_sparse_list )
	SET(cppad_internal_sparse_set  sparse_set )
ENDIF( cppad_sparse_list )
MESSAGE(STATUS "cppad_internal_sparse_set = ${cppad_internal_sparse_set}" )
#
# -----------------------------------------------------------------------------
# cppad_boostvector, cppad_cppadvector, cppad_eigenvector, cppad_stdvector
#
check_match(cppad_testvector boost cppad_boostvector)
check_match(cppad_testvector cppad cppad_cppadvector)
check_match(cppad_testvector eigen cppad_eigenvector)
check_match(cppad_testvector std   cppad_stdvector)
IF( NOT cppad_boostvector )
IF( NOT cppad_cppadvector )
IF( NOT cppad_eigenvector )
IF( NOT cppad_stdvector )
MESSAGE(FATAL_ERROR 
"cppad_testvector not one of following: boost, cppad, eigen, std." 
)
ENDIF( NOT cppad_stdvector )
ENDIF( NOT cppad_eigenvector )
ENDIF( NOT cppad_cppadvector )
ENDIF( NOT cppad_boostvector )

IF( cppad_boostvector )
	# FIND_PACKAGE(Boost) done by ../CMakeLists.txt
	IF( NOT Boost_FOUND )
		MESSAGE(FATAL_ERROR 
"cppad_testvector == boost but cannot find boost include files"
		)
	ENDIF( NOT Boost_FOUND )
ENDIF( cppad_boostvector )
#
IF( cppad_eigenvector )
	IF( NOT eigen_prefix )
		MESSAGE(FATAL_ERROR 
"cppad_testvector == eigen but eigen_prefix is not specified"
		)
	ENDIF( NOT eigen_prefix )
ENDIF( cppad_eigenvector )

# -----------------------------------------------------------------------------
# cppad_has_nullptr
#
# CHECK_CXX_SOURCE_RUNS(source variable)
SET(CMAKE_REQUIRED_INCLUDES  "")
SET(CMAKE_REQUIRED_LIBRARIES "")
SET(CMAKE_REQUIRED_FLAGS     ${cppad_cxx_flags})
SET(source "
int main(void)
{	char *c = nullptr;
	return 0;
}" )
CHECK_CXX_SOURCE_RUNS("${source}" nullptr_ok)
IF( nullptr_ok )
	SET(cppad_has_nullptr 1)
ELSE( nullptr_ok )
	SET(cppad_has_nullptr 0)
ENDIF( nullptr_ok )
MESSAGE(STATUS "cppad_has_nullptr = ${cppad_has_nullptr}" )

# -----------------------------------------------------------------------------
# cppad_has_gettimeofday
#
# CHECK_CXX_SOURCE_RUNS(source variable)
SET(CMAKE_REQUIRED_INCLUDES  "")
SET(CMAKE_REQUIRED_LIBRARIES "")
SET(CMAKE_REQUIRED_FLAGS     "")
SET(source "
# include<sys/time.h>
int main(void)
{	struct timeval time;
	gettimeofday(&time, 0);
	return 0;
}" )
CHECK_CXX_SOURCE_RUNS("${source}" gettimeofday_ok)
IF( gettimeofday_ok )
	SET(cppad_has_gettimeofday 1)
ELSE( gettimeofday_ok )
	SET(cppad_has_gettimeofday 0)
ENDIF( gettimeofday_ok )
MESSAGE(STATUS "cppad_has_gettimeofday = ${cppad_has_gettimeofday}" )
# -----------------------------------------------------------------------------
# cppad_size_t_same_unsigned_int
#
# CHECK_CXX_SOURCE_RUNS(source variable)
SET(CMAKE_REQUIRED_INCLUDES  "")
SET(CMAKE_REQUIRED_LIBRARIES "")
SET(CMAKE_REQUIRED_FLAGS     "")
SET(source "
# include <cstring>
template <class T> inline bool is_pod(void)               { return false; }
template <>        inline bool is_pod<unsigned int>(void) { return true;  }  
template <>        inline bool is_pod<size_t>(void)       { return true;  }  
int main(void)
{	return 0; }
" )
CHECK_CXX_SOURCE_RUNS("${source}" size_t_not_unsigned_int)
IF( size_t_not_unsigned_int )
	SET(cppad_size_t_same_unsigned_int 0)
ELSE( size_t_not_unsigned_int )
	SET(cppad_size_t_same_unsigned_int 1)
ENDIF( size_t_not_unsigned_int )
MESSAGE(STATUS 
	"cppad_size_t_same_unsigned_int = ${cppad_size_t_same_unsigned_int}" 
)
# -----------------------------------------------------------------------------
# cppad_tape_addr_type, cppad_tape_id_type
#
FOREACH( cmake_var cppad_tape_id_type cppad_tape_addr_type )
	SET(source "
# include <limits>
int main(void)
{	bool is_signed = std::numeric_limits<${${cmake_var}}>::is_signed;
	return int(! is_signed);
}
" )
	CHECK_CXX_SOURCE_RUNS("${source}" ${cmake_var}_is_signed)
	IF( ${cmake_var}_is_signed  )
		MESSAGE(STATUS 
"Warning: using a signed ${cmake_var} (for CppAD developers not users)" 
	)
	ENDIF( ${cmake_var}_is_signed  )
ENDFOREACH( cmake_var )
# -----------------------------------------------------------------------------
# cppad_max_num_threads
#
SET(source "
int main(void)
{	const char* number = \"${cppad_max_num_threads}\";
	int value = 0;
	while( '0' <= *number && *number <= '9' && *number != char(0) )
	{	value = 10 * value + (int)(*number - '0');
		number++;
	}
	if( *number != char(0) )
		return 1;
	if( value < 4 )
		return 1;
	return 0;
}
" )
CHECK_CXX_SOURCE_RUNS("${source}" cppad_max_num_threads_is_integer_ge_4)
IF( NOT cppad_max_num_threads_is_integer_ge_4 )
	MESSAGE(FATAL_ERROR 
	"cppad_max_num_threads is not an integer greater than or equal 4"
	)
ENDIF( NOT cppad_max_num_threads_is_integer_ge_4 )

# -----------------------------------------------------------------------------
# Copy a file to another location and modify its contents.
# configure_file(InputFile OutputFile [COPYONLY] [ESCAPE_QUOTES] [@ONLY])
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp.in             
	${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp
)

=== cppad_ipopt/CMakeLists.txt ===
# $Id: CMakeLists.txt 2683 2012-12-30 18:17:03Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/* directory tests 
# Inherit environment from ../CMakeList.txt

# Initialize list of tests as empty
SET(list_ipopt_nlp "")

# assert ipopt_prefix is defined
IF ( NOT ipopt_prefix )
	MESSAGE(FATAL_ERROR 
		"cppad_ipopt/speed/CMakeLists.txt: ipopt_prefix = ${ipopt_prefix}"
	)
ENDIF ( NOT ipopt_prefix )

# The CMakeLists.txt file in the specified source directory is processed 
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
ADD_SUBDIRECTORY(src)
#
ADD_SUBDIRECTORY(example)
add_to_list(list_ipopt_nlp check_example_ipopt_nlp)
#
ADD_SUBDIRECTORY(speed)
add_to_list(list_ipopt_nlp check_speed_ipopt_nlp)
#
ADD_SUBDIRECTORY(test)
add_to_list(list_ipopt_nlp check_test_more_ipopt_nlp)

# Add the check_ipopt_nlp target
ADD_CUSTOM_TARGET(check_ipopt_nlp DEPENDS ${list_ipopt_nlp} )

=== example/CMakeLists.txt ===
# $Id: CMakeLists.txt 2991 2013-10-22 16:25:15Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-13 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the example directory tests 
# Inherit environment from ../CMakeList.txt

# Specifies build type for this directory. Possible values are 
# empty, Debug, Release, RelWithDebInfo and MinSizeRel
SET(CMAKE_BUILD_TYPE DEBUG)

# atomic examples
ADD_SUBDIRECTORY(atomic)

# adolc_prefix
IF ( adolc_prefix )
	# Extra source files if we are including adolc
	SET(adolc_sources 
		mul_level_adolc.cpp mul_level_adolc_ode.cpp
	)
	# Adds -D define flags to the compilation of source files.
	ADD_DEFINITIONS("-DCPPAD_ADOLC_EXAMPLES")
	# add adolc to list of libraries
	SET(example_adolc adolc)
ELSE ( adolc_prefix )
	SET(adolc_sources "")
	SET(example_adolc "")
ENDIF ( adolc_prefix )

# eigen_prefix
IF ( eigen_prefix )
	# compile eigen library separately so can use different compiler flags
	ADD_LIBRARY(example_eigen 
		eigen_det.cpp
		eigen_array.cpp
	)
	# Adds -D define flags to the compilation of source files.
	ADD_DEFINITIONS("-DCPPAD_EIGEN_EXAMPLES")
	add_cppad_cxx_flags(example_eigen)
	#
	# Add eigen to list of libraries
	SET(example_eigen example_eigen)
ELSE ( eigen_prefix )
	SET(example_eigen "")
ENDIF ( eigen_prefix )

# ipopt_prefix
IF( ipopt_prefix )
	ADD_SUBDIRECTORY(ipopt_solve)
	SET(example_ipopt check_example_ipopt_solve)
ELSE( ipopt_prefix )
	SET(example_ipopt "")
ENDIF( ipopt_prefix )


# Copy a file to another location and modify its contents.
# configure_file(InputFile OutputFile [COPYONLY] [ESCAPE_QUOTES] [@ONLY])
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/test_one.sh.in             
	${CMAKE_CURRENT_SOURCE_DIR}/test_one.sh
)


# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
ADD_EXECUTABLE(example EXCLUDE_FROM_ALL example.cpp
	${adolc_sources}
	abort_recording.cpp
	abs.cpp
	acos.cpp
	add.cpp
	add_eq.cpp
	ad_assign.cpp
	ad_ctor.cpp
	ad_fun.cpp
	ad_in_c.cpp
	ad_input.cpp
	ad_output.cpp
	asin.cpp
	atan.cpp
	atan2.cpp
	base_alloc.hpp
	base_require.cpp
	bender_quad.cpp
	bool_fun.cpp
	capacity_taylor.cpp
	change_const.cpp
	check_for_nan.cpp
	check_numeric_type.cpp
	check_simple_vector.cpp
	compare.cpp
	compare_change.cpp
	complex_poly.cpp
	cond_exp.cpp
	conj_grad.cpp
	cos.cpp
	cosh.cpp
	cppad_vector.cpp
	div.cpp
	div_eq.cpp
	equal_op_seq.cpp
	erf.cpp
	error_handler.cpp
	exp.cpp
	for_one.cpp
	for_two.cpp
	forward.cpp
	forward_mul.cpp
	for_sparse_jac.cpp
	fun_assign.cpp
	fun_check.cpp
	hes_lagrangian.cpp
	hes_lu_det.cpp
	hes_minor_det.cpp
	hessian.cpp
	hes_times_dir.cpp
	independent.cpp
	index_sort.cpp
	integer.cpp
	interface2c.cpp
	interp_onetape.cpp
	interp_retape.cpp
	jac_lu_det.cpp
	jac_minor_det.cpp
	jacobian.cpp
	limits.cpp
	log.cpp
	log10.cpp
	lu_factor.cpp
	lu_invert.cpp
	lu_ratio.cpp
	lu_solve.cpp
	lu_vec_ad.cpp
	lu_vec_ad.hpp
	lu_vec_ad_ok.cpp
	mul.cpp
	mul_eq.cpp
	mul_level.cpp
	mul_level_ode.cpp
	nan.cpp
	near_equal.cpp
	near_equal_ext.cpp
	not_complex_ad.cpp
	number_skip.cpp
	numeric_type.cpp
	ode_err_control.cpp
	ode_err_maxabs.cpp
	ode_gear.cpp
	ode_gear_control.cpp
	ode_stiff.cpp
	ode_taylor.cpp
	omp_alloc.cpp
	opt_val_hes.cpp
	optimize.cpp
	par_var.cpp
	poly.cpp
	pow.cpp
	pow_int.cpp
	print_for.cpp
	reverse_any.cpp
	reverse_one.cpp
	reverse_three.cpp
	reverse_two.cpp
	rev_one.cpp
	rev_sparse_hes.cpp
	rev_sparse_jac.cpp
	rev_two.cpp
	romberg_mul.cpp
	romberg_one.cpp
	rosen_34.cpp
	runge45_1.cpp
	runge45_2.cpp
	seq_property.cpp
	simple_vector.cpp
	sign.cpp
	sin.cpp
	sinh.cpp
	sparse_hessian.cpp
	sparse_jacobian.cpp
	sqrt.cpp
	stack_machine.cpp
	sub.cpp
	sub_eq.cpp
	tan.cpp
	tanh.cpp
	tape_index.cpp
	thread_alloc.cpp
	unary_minus.cpp
	unary_plus.cpp
	value.cpp
	var2par.cpp
	vec_ad.cpp
	vector_bool.cpp 
)

# Compiler flags for cppad source
add_cppad_cxx_flags(example) 

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example ${example_adolc} ${example_eigen})

# Add the check_example target
ADD_CUSTOM_TARGET(check_example example DEPENDS 
	example 
	check_example_atomic 
	${example_ipopt}
)

=== multi_thread/CMakeLists.txt ===
# $Id: CMakeLists.txt 2595 2012-11-20 17:39:25Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the multi_thread/* directory tests 
# Inherit environment from ../CMakeList.txt

# initialize list as empty
SET(list_multi_thread "")

# Define the operation
# CHECK_LIBRARY_EXISTS (LIBRARY FUNCTION LOCATION VARIABLE)
#	LIBRARY  - the name of the library you are looking for
#	FUNCTION - the name of the function
#	LOCATION - location where the library should be found
#	VARIABLE - variable to store the result
INCLUDE(CheckLibraryExists)

# If openmp found, set OpenMP_CXX_FLAGS and process its subdirectory
#
FIND_PACKAGE(OpenMP)
IF ( OPENMP_FOUND )
	# OpenMP_CXX_FLAGS - flags to add to the CXX compiler for OpenMP support
	ADD_SUBDIRECTORY(openmp)
	add_to_list(list_multi_thread check_openmp)
ENDIF ( OPENMP_FOUND )

# If pthreads found, set pthread_lib and pthread_lib_path and process subdir
#
# find_library(<VAR> name1 [path1 path2 ...])
SET(pthread_lib "pthread")
FIND_LIBRARY(pthread_lib_path pthread)
MESSAGE(STATUS "pthread library path = ${pthread_lib_path}")
IF ( pthread_lib_path )
	CHECK_LIBRARY_EXISTS(
		pthread pthread_barrier_wait ${pthread_lib_path} pthread_ok
	)   
	IF ( pthread_ok )
		ADD_SUBDIRECTORY(pthread)
		add_to_list(list_multi_thread check_pthread)
	ENDIF ( pthread_ok )
ENDIF ( pthread_lib_path )

# If boost threads found, set 
# bthread_lib, bthread_lib_path and process its subdir
# 
# FIND_PACKAGE(Boost) was done by ../CMakeLists.txt
IF ( Boost_FOUND )
	#
	SET(CMAKE_REQUIRED_INCLUDES  "${boost_prefix}/${cmake_install_includdir}")
	#
	SET(bthread_lib               "boost_thread" )
	SET(CMAKE_REQUIRED_LIBRARIES "${bthread_lib}" )
	#
	SET(bthread_lib_path "${boost_prefix}/${cppad_install_libdir}" )
	SET(CMAKE_REQUIRED_FLAGS     "-L${bthread_lib_path}" )
	#
	# CHECK_CXX_SOURCE_RUNS(source variable)
	SET(source "
# include <boost/thread.hpp>
int main(void) 
{	boost::barrier wait(1);
	return 0;
}"	)
	CHECK_CXX_SOURCE_RUNS("${source}" bthread_ok)
	#
	IF ( NOT bthread_ok )
		SET(bthread_lib               "boost_thread-mt" )
		SET(CMAKE_REQUIRED_LIBRARIES "${bthread_lib}" )
		CHECK_CXX_SOURCE_RUNS("${source}" bthread_mt_ok)
	ENDIF ( NOT bthread_ok )
	IF ( bthread_ok OR bthread_mt_ok )
		ADD_SUBDIRECTORY(bthread)
		add_to_list(list_multi_thread check_bthread)
	ENDIF ( bthread_ok OR bthread_mt_ok )
ENDIF ( Boost_FOUND )

# check_multi_thread
ADD_CUSTOM_TARGET(check_multi_thread DEPENDS ${list_multi_thread})

=== pkgconfig/CMakeLists.txt ===
#CppAD $Id: CMakeLists.txt 2606 2012-12-15 14:08:30Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad pkg-config information files.
# Inherit environment from ../CMakeLists.txt
#
SET(cppad_cflags "-I${cppad_abs_includedir}")
SET(cppad_libs "")
SET(cppad_requires "")
IF( ipopt_prefix )
	SET(cppad_libs "-L${cppad_abs_libdir} -lcppad_ipopt")
	SET(cppad_requires "ipopt")
	FOREACH(dir ${cmake_install_includedirs})
		IF(IS_DIRECTORY ${ipopt_prefix}/${dir} )
			SET(cppad_cflags "${cppad_cflags} -I${ipopt_prefix}/${dir}" )
		ENDIF(IS_DIRECTORY ${ipopt_prefix}/${dir} )
	ENDFOREACH(dir)
ENDIF( ipopt_prefix )
MESSAGE(STATUS "cppad_cflags = ${cppad_cflags}")
MESSAGE(STATUS "cppad_libs = ${cppad_libs}")
MESSAGE(STATUS "cppad_requires = ${cppad_requires}")
#
# Copy a file to another location and modify its contents.
# configure_file(InputFile OutputFile [COPYONLY] [ESCAPE_QUOTES] [@ONLY])
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/cppad.pc.in             
	${CMAKE_CURRENT_BINARY_DIR}/cppad.pc 
)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/cppad-uninstalled.pc.in 
	${CMAKE_CURRENT_BINARY_DIR}/cppad-uninstalled.pc
)
# During install copy cppad.pc to CMAKE_INSTALL_PREFIX/
# install(FILES files... DESTINATION <dir>
#	[PERMISSIONS permissions...]
#	[CONFIGURATIONS [Debug|Release|...]]
#	[COMPONENT <component>]
#	[RENAME <name>] [OPTIONAL])
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc DESTINATION ${cppad_abs_datadir}/pkgconfig )

=== print_for/CMakeLists.txt ===
# $Id: CMakeLists.txt 2564 2012-11-12 21:55:25Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the print_for directory tests 
# Inherit environment from ../CMakeList.txt

# Specifies build type for this directory. Possible values are 
# empty, Debug, Release, RelWithDebInfo and MinSizeRel
SET(CMAKE_BUILD_TYPE DEBUG)

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
ADD_EXECUTABLE(print_for EXCLUDE_FROM_ALL print_for.cpp)

# Add extra compiler flags
add_cppad_cxx_flags(print_for)

# Add the check_print_for target
ADD_CUSTOM_TARGET(check_print_for print_for DEPENDS print_for)

=== speed/CMakeLists.txt ===
# $Id: CMakeLists.txt 2565 2012-11-12 23:16:00Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the speed/* directory tests 
# Inherit environment from ../CMakeList.txt

# Initialize list of tests as empty
SET(list_speed "")

# The CMakeLists.txt file in the specified source directory is processed 
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
ADD_SUBDIRECTORY(src)
#
ADD_SUBDIRECTORY(cppad)
add_to_list(list_speed check_speed_cppad)
#
ADD_SUBDIRECTORY(double)
add_to_list(list_speed check_speed_double)
#
ADD_SUBDIRECTORY(example)
add_to_list(list_speed check_speed_example)
#
ADD_SUBDIRECTORY(profile)
add_to_list(list_speed check_speed_profile)
#
IF ( adolc_prefix )
	ADD_SUBDIRECTORY(adolc)
	add_to_list(list_speed check_speed_adolc)
ENDIF( adolc_prefix )
IF ( fadbad_prefix )
	ADD_SUBDIRECTORY(fadbad)
	add_to_list(list_speed check_speed_fadbad)
ENDIF( fadbad_prefix )
IF ( sacado_prefix )
	ADD_SUBDIRECTORY(sacado)
	add_to_list(list_speed check_speed_sacado)
ENDIF( sacado_prefix )

# check_speed
ADD_CUSTOM_TARGET(check_speed DEPENDS ${list_speed} )

=== test_more/CMakeLists.txt ===
# $Id: CMakeLists.txt 2862 2013-05-29 05:58:38Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-13 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the test_more directory tests 
# Inherit environment from ../CMakeList.txt

# Specifies build type for this directory. Possible values are 
# empty, Debug, Release, RelWithDebInfo and MinSizeRel
SET(CMAKE_BUILD_TYPE DEBUG)

# This directory does not contain any multi-threading tests, so
# test using CPPAD_MAX_NUM_THREADS equal to one (its smallest value)
ADD_DEFINITIONS("-DCPPAD_MAX_NUM_THREADS=1")

# sources that use adolc
IF ( adolc_prefix )
	# Extra source files if we are including adolc
	SET(adolc_sources base_adolc.cpp)
	# Adds -D define flags to the compilation of source files.
	ADD_DEFINITIONS("-DCPPAD_ADOLC_TEST")
	# add adolc to list of libraries
	SET(test_more_adolc adolc)
ELSE ( adolc_prefix )
	SET(adolc_sources "")
	SET(test_more_adolc "")
ENDIF ( adolc_prefix )

# sources that use ipopt
IF ( ipopt_prefix )
	# Extra source files if we are including ipopt
	SET(ipopt_sources ipopt_solve.cpp)
	# Adds -D define flags to the compilation of source files.
	ADD_DEFINITIONS("-DCPPAD_IPOPT_TEST")
	# add ipopt (and libraries it depends on) to list of libraries
	SET(test_more_ipopt ${ipopt_LIBRARIES} )
ELSE ( ipopt_prefix )
	SET(ipopt_sources "")
	SET(test_more_ipopt "")
ENDIF ( ipopt_prefix )

# sources that use eigen
IF ( eigen_prefix )
	# compile eigen library separately so can use different compiler flags
	ADD_LIBRARY(test_more_eigen EXCLUDE_FROM_ALL cppad_eigen.cpp)
	# Adds -D define flags to the compilation of source files.
	ADD_DEFINITIONS("-DCPPAD_EIGEN_TEST")
	# Add other compiler flags 
	add_cppad_cxx_flags(test_more_eigen) 
	#
	# Add eigen to list of libraries
	SET(test_more_eigen test_more_eigen)
ELSE ( eigen_prefix )
	SET(eigen_sources "")
	SET(test_more_eigen "")
ENDIF ( eigen_prefix )

# Copy a file to another location and modify its contents.
# configure_file(InputFile OutputFile [COPYONLY] [ESCAPE_QUOTES] [@ONLY])
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/test_one.sh.in             
	${CMAKE_CURRENT_SOURCE_DIR}/test_one.sh
)

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
ADD_EXECUTABLE(test_more EXCLUDE_FROM_ALL test_more.cpp
	${adolc_sources}
	${ipopt_sources}
	${eigen_sources}
	abs.cpp
	acos.cpp
	asin.cpp
	assign.cpp
	add.cpp
	add_eq.cpp
	add_zero.cpp
	atan.cpp
	atan2.cpp
	base_alloc.cpp
	check_simple_vector.cpp
	checkpoint.cpp
	compare.cpp
	compare_change.cpp
	cond_exp.cpp
	cond_exp_ad.cpp
	copy.cpp
	cos.cpp
	cosh.cpp
	dbl_epsilon.cpp
	div.cpp
	div_eq.cpp
	div_zero_one.cpp
	erf.cpp
	exp.cpp
	extern_value.cpp
	for_hess.cpp
	for_sparse_jac.cpp
	forward.cpp
	forward_mul.cpp
	from_base.cpp
	fun_check.cpp
	jacobian.cpp
	limits.cpp
	log.cpp
	log10.cpp
	mul.cpp
	mul_eq.cpp
	mul_level.cpp
	mul_zero_one.cpp
	ndebug.cpp
	near_equal_ext.cpp
	neg.cpp
	ode_err_control.cpp
	optimize.cpp
	parameter.cpp
	poly.cpp
	pow.cpp
	pow_int.cpp
	print_for.cpp
	romberg_one.cpp
	rosen_34.cpp
	runge_45.cpp
	reverse.cpp
	rev_sparse_hes.cpp
	rev_sparse_jac.cpp
	rev_two.cpp
	simple_vector.cpp
	sin.cpp
	sin_cos.cpp
	sinh.cpp
	sparse_hessian.cpp
	sparse_jacobian.cpp
	sparse_vec_ad.cpp
	sqrt.cpp
	std_math.cpp
	sub.cpp
	sub_eq.cpp
	sub_zero.cpp
	tan.cpp
	test_vector.cpp
	track_new_del.cpp
	value.cpp
	vec_ad.cpp
	vec_ad_par.cpp
	vec_unary.cpp 
)

# Compiler flags for cppad source
add_cppad_cxx_flags(test_more)

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(test_more 
	${test_more_adolc} 
	${test_more_ipopt}
	${test_more_eigen}
)

# Add the check_test_more target
ADD_CUSTOM_TARGET(
	check_test_more test_more DEPENDS test_more ${test_more_eigen} 
)

=== cppad_ipopt/example/CMakeLists.txt ===
# $Id: CMakeLists.txt 2683 2012-12-30 18:17:03Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/example directory tests 
# Inherit environment from ../CMakeList.txt

# Specifies build type for this directory. Possible values are 
# empty, Debug, Release, RelWithDebInfo and MinSizeRel
SET(CMAKE_BUILD_TYPE DEBUG)

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
LINK_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR}/../src ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
ADD_EXECUTABLE(example_ipopt_nlp EXCLUDE_FROM_ALL 
	example.cpp
	get_started.cpp
	ode_check.cpp
	ode_check.hpp
	ode_fast_check.cpp
	ode_fast.hpp
	ode_problem.hpp
	ode_run.hpp
	ode_simple_check.cpp
	ode_simple.hpp
)

# Extra compiler flags
add_cppad_cxx_flags( example_ipopt_nlp )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_ipopt_nlp cppad_ipopt ${ipopt_LIBRARIES})

# Add the check_example_ipopt_nlp target
ADD_CUSTOM_TARGET(check_example_ipopt_nlp
	example_ipopt_nlp
	DEPENDS example_ipopt_nlp cppad_ipopt
)

=== cppad_ipopt/speed/CMakeLists.txt ===
# $Id: CMakeLists.txt 2683 2012-12-30 18:17:03Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/speed directory tests 
# Inherit environment from ../CMakeList.txt

# Specifies build type for this directory. Possible values are 
# empty, Debug, Release, RelWithDebInfo and MinSizeRel
SET(CMAKE_BUILD_TYPE RELEASE)

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
# (cannot use ../src/cppad_ipopt library because it is linke with debugging)
LINK_DIRECTORIES( ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
# Include source for cppad_ipopt library so we build it without debugging 
ADD_EXECUTABLE(speed_ipopt_nlp EXCLUDE_FROM_ALL 
	speed.cpp
	../src/cppad_ipopt_nlp.cpp
	../src/fun_record.hpp
	../src/hes_fg_map.cpp
	../src/jac_g_map.cpp
	../src/sparse_map2vec.cpp
	../src/vec_fun_pattern.cpp
	ode_speed.cpp 
)

# Add extra compiler flags
add_cppad_cxx_flags( speed_ipopt_nlp )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(speed_ipopt_nlp cppad_ipopt ${ipopt_LIBRARIES})

# Add the check_speed_ipopt_nlp target
ADD_CUSTOM_TARGET(check_speed_ipopt_nlp
	speed_ipopt_nlp
	DEPENDS speed_ipopt_nlp cppad_ipopt
)

=== cppad_ipopt/src/CMakeLists.txt ===
# $Id: CMakeLists.txt 2595 2012-11-20 17:39:25Z bradbell $
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-12 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the 
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/src library
# Inherit environment from ../CMakeList.txt

# Specifies build type for this directory. Possible values are 
# empty, Debug, Release, RelWithDebInfo and MinSizeRel
SET(CMAKE_BUILD_TYPE DEBUG)

#  add_library(<name> [STATIC | SHARED | MODULE] [EXCLUDE_FROM_ALL]
#	source1 source2 ... sourceN)
# )
ADD_LIBRARY(cppad_ipopt 
	cppad_ipopt_nlp.cpp
	hes_fg_map.cpp
	jac_g_map.cpp
	sparse_map2vec.cpp
	vec_fun_pattern.cpp 
)

# Add extra compiler flags
add_cppad_cxx_flags( cppad_ipopt )

# install(FILES files... DESTINATION <dir>
#	[PERMISSIONS permissions...]
#	[CONFIGURATIONS [Debug|Release|...]]
#	[COMPONENT <component>]
#	[RENAME <name>] [OPTIONAL])
INSTALL(FILES cppad_ipopt_nlp.hpp DESTINATION ${cppad_abs_includedir})

# install(TARGETS myExe mySharedLib myStaticLib
#	RUNTIME DESTINATION bin
#	LIBRARY DESTINATION lib
#	ARCHIVE DESTINATION lib/static)
INSTALL(TARGETS cppad_ipopt DESTINATION ${cppad_abs_libdir})

=== debian/changelog ===
cppad (2014.00.00.3-1) unstable; urgency=medium

  * Initial release (Closes: #742899)
    - Based on initial work by Barak A. Pearlmutter

 -- Miles Lubin <miles.lubin@gmail.com>  Tue, 08 Apr 2014 15:27:03 +0100

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper (>= 9), cmake, libboost-dev
Standards-Version: 3.9.5
Homepage: http://www.coin-or.org/CppAD/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/cppad.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/cppad.git

Package: cppad
Architecture: all
Depends: ${misc:Depends}
Description: Automatic Differentiation (AD) of C++ algorithms
 CppAD is a package for automatic differentiation of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains C++ header files and documentation.
